# coding: utf-8
"""
 :copyright: (c) 2011 Philipp Benjamin Köppchen
 :license: GPLv3, see LICENSE for more details.
"""
from __future__ import absolute_import

from .base import Persistent, docproperty


class Achievement(Persistent):
    """
    Example document:

    {
        'id': ObjectId('C0FFEEBABE'),
        'name': 'Basic Achievement',
        'description': 'This is a basic Achievement, given to everyone',
    }
    """
    id = docproperty("id")
    name = docproperty("name")
    description = docproperty("description")

    @property
    def realm(self):
        return self.parent

    def get_users(self):
        from .user import User
        return User.find_by_filter({
                         'realms.%s.achievements' % self.parent.name: self.id})
